<template>
  <q-layout
    view="hHh Lpr lff"
    class="html body"
  >
    <q-header
      class="page-header"
    >
      <q-toolbar>
        <img
          src="~assets/EMPAIA_Logo-Color(white)datamanager.png"
          class="header-logo"
        >
        <q-space />
        <q-btn
          v-if="authorized&&uploadProgress>0&&uploadProgress<100"
          id="menu"
          :loading="true"
          :percentage="uploadProgress"
          color="empaia"
          outline
          style="line-height: 36px; letter-spacing: .0892857143em; font-size: 14px; min-width:250px"
        >
          <template v-slot:loading>
            Upload {{ uploadProgress }}%
          </template>
          <q-menu fit>
            <q-list style="width: 250px">
              <q-item
                v-for="uploadingCase in uploadingCases"
                :key="uploadingCase.id"
                v-close-popup
                clickable
                class="upload-item"
                @click="openCase(uploadingCase.id)"
              >
                <q-item-section><b>{{ uploadingCase.label }}</b></q-item-section>
                <q-item-section style="text-align: right">
                  {{ uploadingCase.progress }} %
                </q-item-section>
              </q-item>
            </q-list>
          </q-menu>
        </q-btn>
        <q-space />
        <q-btn
          v-if="authorized&&username"
          id="menu"
          flat
          dense
          no-caps
          icon-right="more_vert"
          padding="0px 10px"
          color="primary"
          style="margin-right: 4px; margin-top:20px; line-height: 36px; letter-spacing: .0892857143em; font-size: 14px"
        >
          <b>{{ username }}</b>
          <q-menu fit>
            <q-list>
              <q-item
                v-close-popup
                clickable
                @click="help = true"
              >
                <q-item-section
                  avatar
                >
                  <q-icon name="question_mark" />
                </q-item-section>
                <q-item-section>
                  Help
                </q-item-section>
              </q-item>
              <q-item
                id="logout"
                v-close-popup
                clickable
                @click="logout"
              >
                <q-item-section
                  avatar
                >
                  <q-icon name="logout" />
                </q-item-section>
                <q-item-section>Logout</q-item-section>
              </q-item>
            </q-list>
          </q-menu>
        </q-btn>
      </q-toolbar>
    </q-header>

    <q-footer
      v-if="authorized"
      class="page-footer"
    >
      <div
        class="text-red text-weight-bold"
        style="margin: 10px; text-align: center"
      >
        For research purposes only: Data must be anonymized and approved for research purposes before uploading.
      </div>
    </q-footer>

    <q-page-container
      v-if="authorized"
    >
      <router-view
        :creator-id="userid"
      />
    </q-page-container>
    <q-page-container
      v-if="!authorized&&showLogin"
      class="absolute-center"
    >
      <div style="width: 300px; text-align: center">
        <img
          src="~assets/EMPAIA_LOGO_COLOR.png"
          style="width: 300px"
        >
      </div><br>
      <div style="width: 300px; text-align: center">
        You are currently not logged in.
      </div><br>
      <q-btn
        style="width: 300px"
        outline
        label="Login"
        icon="login"
        @click="signIn"
      />
    </q-page-container>
    <q-page-container
      v-if="showSlideViewer"
      class="absolute-top"
      style="background-color: #fff; bottom: 0px"
    >
      <q-btn
        flat
        dense
        icon="close"
        style="float: right; padding-top: 0px; padding-bottom: 0px"
        @click="showSlideViewer = false"
      >
        <q-tooltip
            anchor="top middle"
            self="bottom middle"
            :offset="[15, 15]"
          >
            Close
          </q-tooltip>
      </q-btn>

      <div id="map" class="map">
      </div><br>
    </q-page-container>
    <q-dialog
      v-model="help"
    >
      <q-card style="padding: 10px; width: 100%; max-width: 1500px;">
        <q-toolbar>
          <img
            src="~assets/EMPAIA_Logo-Color(white)datamanager.png"
            height="50px"
            class="empaia-logo-help-dialog"
          >

          <q-toolbar-title />

          <q-btn
            v-close-popup
            flat
            round
            dense
            icon="close"
          />
        </q-toolbar>

        <q-card-section style="padding: 10px; font-size: 16px">
          <b style="font-size: 18px">Quickstart</b><br><br>
          <b>Create a case</b><br>
          Click <q-btn
            outline
            size="sm"
            color="primary"
            label="Create new Case"
          /> to create a case. You must provide an ID and description for a case to be able to create it.
          After everything is filled in, click <q-btn
            class="q-ma-sm"
            outline
            size="sm"
            label="Create Case"
          /> to add the case.
          The first time you generate a case, you must confirm that you will never enter patient information into any input field.<br><br>
          <b>Upload a slide</b><br>
          If a case has just been created, it will be opened automatically.
          If you want to upload the slide to another case, select or search for the corresponding case in the case selection.<br>
          Once a case is selected, you can start uploading the corresponding slide or slides.
          Click <q-btn
            outline
            size="sm"
            color="primary"
            label="Add new slide"
          /> and open the file manager of your operating system and drag and drop one or more files to "Drop slides here".
          It is allowed to drop many different files and folders. Unsupported files will be filtered automatically.
          Alternatively, the file selection can also be done directly via the two buttons
          <q-btn
            outline
            size="sm"
            color="primary"
            label="Select File"
          />
          and
          <q-btn
            outline
            size="sm"
            color="primary"
            label="Select Folder"
          />.
          Files can also be added gradually to the queue via the various inputs.<br>
          If the file has been dropped, it is checked and client-side anonymization is automatically performed for supported formats. The upload can now be started with <q-btn
            icon="upload"
            color="grey"
            size="sm"
            round
          />.
          In the case of the first upload or anonymization failure, you must confirm that the slides do not contain data that could identify a patient.
          It is also possible to start individual files in the queue or remove them from the queue.
          <br>
          As soon as the upload is finished, the slide will be shown in the overview.<br><br>
          <b>Set tissue and stain for a slide</b><br>
          For each slide, the tissue type and the staining used can be set. This is possible via the corresponding fields per slide.
          In the fields, a quick search is also possible using a few letters, the selection can then be confirmed with ENTER.
          <br><br>
          <b>Request preprocessing for a slide</b><br>
          Click <q-btn
            outline
            style="color: black;"
            icon="settings"
            size="sm"
            dense
          /> within the slide view. A dialog is displayed. If stain and tissue are defined, the preprocessing can be requested
          by clicking the "Request Preprocessing" button. Otherwise, there is a warning and stain and tissue must be added.
          Sometimes there is also a warning about already defined preprocessing requests. In this case you should be careful
          and request another preprocessing only if the preprocessing triggers have been changed since the last request.
          <br><br>
          <b>Delete a case or slide</b><br>
          By clicking <q-btn
            outline
            style="color: black;"
            icon="delete"
            size="sm"
            dense
          /> next to the case you are able to delete a whole case including all slides. If only one slide is to be deleted, <q-btn
            outline
            style="color: black;"
            icon="delete"
            size="sm"
            dense
          /> can be clicked within the slide view.
          The deletion must then be confirmed.
          <br><br>
          <b style="font-size: 18px">Q&A</b><br><br>

          <b>Why is the original file name displayed?</b><br>
          Although the file name for slides is displayed in the overview, it is not transferred to EMPAIA servers, but only stored locally in the browser.
          It is not visible in other browsers or after a browser reset.
          However, the mapping of file names to EMPAIA slide IDs for a case can be saved by clicking <q-btn
            outline
            style="color: black;"
            icon="save_alt"
            size="sm"
            dense
          /> while it is still available in the browser's local storage after the upload.
          <br><br>
          <b>How to upload multi-file slide formats like MRXS or DICOM?</b><br>
          You need to drag and drop all files and folders belonging to the slide at once, e.g. for MRXS the testfile1.mrxs and testfile1 subfolder.
          If you are using the built-in file selector, choose <q-btn
            outline
            size="sm"
            color="primary"
            label="Select Folder"
          />
          and select the parent folder that contains all the files needed for a slide.
          DICOM currently supports only one slide per folder, which of course can consist of many files within that folder.
          <br><br>
          <b style="font-size: 18px">Support</b><br>
          In case of any questions, feel free to use the <a href="https://gitlab.com/empaia/integration/data-management-client/-/issues">issue tracker</a>
          or contact the support at <a href="mailto: support@empaia.org">support@empaia.org</a>
        </q-card-section>
        <br>
        <div
          style="font-size: 12px; text-align: center"
          @click="changeLoggingMode"
        >
          Version {{ version }} - Mode: {{ loggingMode }}
        </div><br>
      </q-card>
    </q-dialog>
  </q-layout>
</template>

<script>
import { UserManager, Log } from 'oidc-client-ts'
import idm from '../mixins/idm_api'
import mds from '../mixins/mds_api'
import getEnv from '../mixins/env'
import axios from 'axios'
import jwtDecode from 'jwt-decode'
import { version } from '../../package.json'
import EventBus from '../mixins/event_bus'
import { sleep } from '../mixins/helpers'
import Projection from 'ol/proj/Projection'
import { addProjection } from 'ol/proj'
import { getCenter } from 'ol/extent'
import TileGrid from 'ol/tilegrid/TileGrid'
import View from 'ol/View'
import Map from 'ol/Map'
import XYZ from 'ol/source/XYZ'
import Tile from 'ol/layer/Tile'
import ScaleLine from 'ol/control/ScaleLine'
import TileLayer from 'ol/layer/Tile'

export default {
  data () {
    return {
      clientId: '',
      authorized: false,
      showLogin: false,
      showSlideViewer: false,
      authLink: '',
      username: '',
      userid: '',
      noAuth: false,
      help: false,
      version: version,
      userManager: null,
      loggingMode: 'standard',
      uploadProgress: 0,
      uploadingCases: []
    }
  },

  async mounted () {
    this.setupAxiosResponseCheck()

    if (getEnv('DMC_STATIC_USER_ID')) {
      this.username = getEnv('DMC_STATIC_USER_ID')
      this.userid = this.username
      this.noAuth = true
      await this.checkAuth()
      return
    }

    this.clientId = getEnv('CLIENT_ID')
    const authUrl = getEnv('AUTH_URL')
    const redirectUri = this.getRedirectUri()

    let accessTokenRenewalBeforeExpiringInS = 150 // default is 2.5 min
    if (getEnv('ACCESS_TOKEN_RENEWAL_BEFORE_EXPIRING_IN_S')) {
      accessTokenRenewalBeforeExpiringInS = parseInt(getEnv('ACCESS_TOKEN_RENEWAL_BEFORE_EXPIRING_IN_S'))
    }

    this.userManager = new UserManager({
      authority: authUrl,
      client_id: this.clientId,
      redirect_uri: redirectUri,
      post_logout_redirect_uri: redirectUri,
      // accessTokenExpiring event is used for silent renew
      accessTokenExpiringNotificationTimeInSeconds: accessTokenRenewalBeforeExpiringInS
    })

    const userManager = this.userManager
    const showTokenExpiredReloadMessage = this.showTokenExpiredReloadMessage
    const showConnectionOffMessage = this.showConnectionOffMessage
    const showConnectionReestablishedMessage = this.showConnectionReestablishedMessage

    // retry silent sign-in in case of silent renew error every 5 seconds
    const getRefreshTokenExpiration = () => {
      let refreshToken = ''
      const clientId = getEnv('CLIENT_ID')
      Object.keys(sessionStorage).forEach(function (key) {
        if (key.includes(clientId)) {
          const values = JSON.parse(sessionStorage.getItem(key))
          if ('refresh_token' in values) {
            refreshToken = values.refresh_token
          }
        }
      })
      return jwtDecode(refreshToken).exp
    }
    const retrySignin = async function (showSuccess = false, dismissError = null) {
      try {
        await userManager.signinSilent()
        console.log('Silent signin successful.')
        EventBus.$emit('resume-uploads')
        if (showSuccess) {
          showConnectionReestablishedMessage()
        }
        if (dismissError) {
          dismissError()
        }
      } catch (error) {
        if (error.message.includes('Failed to fetch')) {
          const dismissError = showConnectionOffMessage()
          console.log('Silent signin failed due to connection issues. Retrying in 5 seconds.')
          await sleep(5000)
          const refreshTokenExpiration = getRefreshTokenExpiration()
          if (refreshTokenExpiration < Date.now() / 1000) {
            showTokenExpiredReloadMessage()
            console.log('Refresh token expired.')
          } else {
            console.log('Refresh token still valid for another', Math.round(refreshTokenExpiration - Date.now() / 1000), 'seconds')
            await retrySignin(true, dismissError)
          }
        }
      }
    }
    this.userManager.events.addSilentRenewError(async () => {
      console.log('Silent renew failed. Retrying with silent signin.')
      await retrySignin()
    })

    Log.setLogger(console)
    Log.setLevel(Log.ERROR)

    if (this.checkAuthCallback()) {
      this.$q.loading.show({ message: 'Authenticating' })
      await this.userManager.signinRedirectCallback()
      this.goHome()
    }
    await this.checkAndSetupToken()
    await this.checkAuth()

    EventBus.$on('upload-progress', (uploadProgress) => {
      this.uploadProgress = uploadProgress
    })
    EventBus.$on('uploading-cases', (uploadingCases) => {
      this.uploadingCases = uploadingCases
    })
    await EventBus.$on('open-slide-viewer', (slide) => {
      this.showSlideViewer = true
      this.openSlideViewer(slide)
    })
  },

  methods: {
    async checkAuth () {
      try {
        await idm.alive()
        this.authorized = true
        this.showLogin = false
      } catch {
        this.authorized = false
        this.showLogin = true
      }
    },

    changeLoggingMode () {
      if (this.loggingMode === 'standard') {
        this.loggingMode = 'debug'
        Log.setLevel(Log.DEBUG)
      } else {
        this.loggingMode = 'standard'
        Log.setLevel(Log.NONE)
      }
    },

    async signIn () {
      this.userManager.signinRedirect()
    },

    checkAuthCallback () {
      const urlParams = new URLSearchParams(window.location.search)
      return urlParams.get('state') !== null
    },

    async checkAndSetupToken () {
      const user = await this.userManager.getUser()
      if (user && user.access_token) {
        const decodedToken = jwtDecode(user.access_token)
        this.username = decodedToken.given_name + ' ' + decodedToken.family_name
        this.userid = decodedToken.sub
        axios.interceptors.request.use(
          async function (config) {
            const user = await this.userManager.getUser()
            config.headers.Authorization = `Bearer ${user.access_token}`
            return config
          }.bind(this),
          error => {
            return Promise.reject(error)
          }
        )
      }
    },

    goHome () {
      const redirectUri = this.getRedirectUri()
      window.location.replace(redirectUri)
    },

    getRedirectUri () {
      return window.location.href.split('#')[0].split('?')[0]
    },

    async logout () {
      await this.userManager.signoutRedirect()
    },

    setupAxiosResponseCheck () {
      axios.interceptors.response.use(response => {
        return response
      },
      async function (error) {
        if (error.response && (error.response.status === 401 || error.response.status === 403)) {
          if (error.response.data && error.response.data.detail && error.response.data.detail === 'API access denied.') {
            let organizationName = getEnv('DMC_ORGANIZATION_NAME')
            organizationName = organizationName || 'EMPAIA'
            this.showErrorMessage(`User is not allowed to access data of the organization ${organizationName}. Please join the organization before login.`)
          }
          this.authorized = false
          this.showLogin = true
        } else {
          if (error.message) {
            // ignore wsi service error, error already displayed within the slide card
            const wsiServiceError = error.config.url.includes('/thumbnail') || error.config.url.includes('/info')
            // ignore upload service deletion error if file not exists
            const uploadServiceError = error.config.url.includes('/files/') && error.response.status === 404 && error.response.data.detail.includes('does not exist')
            if (!wsiServiceError && !uploadServiceError) {
              if (error.message === 'Network Error') {
                this.showConnectionOffMessage()
              } else {
                this.showErrorMessage(`${error.message} (URL: ${error.config.url}).`)
              }
            }
          }
        }
        return Promise.reject(error)
      }.bind(this))
    },

    openCase (caseId) {
      EventBus.$emit('open-case', caseId)
    },

    showErrorMessage (message, timeout = 0) {
      this.$q.notify({
        timeout: timeout,
        type: 'negative',
        message: message,
        actions: [
          { label: 'Ok', color: 'white', handler: () => {} }
        ]
      })
    },

    showConnectionOffMessage () {
      return this.$q.notify({
        timeout: 0,
        type: 'negative',
        message: 'Connection issues. Please check your internet connection.',
        icon: 'cloud_off',
        actions: [
          { label: 'Ok', color: 'white', handler: () => {} }
        ]
      })
    },

    showConnectionReestablishedMessage () {
      this.$q.notify({
        timeout: 2000,
        type: 'positive',
        message: 'Connection re-established',
        icon: 'cloud_done',
        actions: [
          { label: 'Ok', color: 'white', handler: () => {} }
        ]
      })
    },

    showTokenExpiredReloadMessage () {
      this.$q.notify({
        timeout: 0,
        type: 'negative',
        message: 'Refresh token expired due to connection issues.',
        icon: 'cloud_off',
        actions: [
          { label: 'Reload Page', color: 'white', handler: () => { this.goHome() } }
        ]
      })
    },

    async openSlideViewer(slide){
      const userManager = await this.userManager
      mds.getSlideInfo(slide.id)
          .then(function (response) {
              const wsiInfo = response
              const pixelSizeNm = (wsiInfo.pixel_size_nm.x + wsiInfo.pixel_size_nm.y) / 2.0
              const extent = [0, -wsiInfo.extent.y, wsiInfo.extent.x ,0] // we are using the fourth quadrant
              const tileSize = [wsiInfo.tile_extent.x, wsiInfo.tile_extent.y]
              const resolutions = []

              if (wsiInfo.levels[wsiInfo.levels.length - 1].downsample_factor < 128) {
                  resolutions.push(128)
              }
              for (let i = wsiInfo.levels.length - 1; i >= 0; i--) {
                  resolutions.push(wsiInfo.levels[i].downsample_factor)
              }

              const numLevels = resolutions.length
              const minZoom = numLevels - wsiInfo.levels.length

              const projection = new Projection({
                code: 'pixels',
                units: 'pixels',
                metersPerUnit: pixelSizeNm * 1e-9,
                getPointResolution: function (resolution) {
                    return resolution
                }
              })
              addProjection(projection)
              const tileGrid = new TileGrid({
                resolutions: resolutions,
                extent: extent,
                origin: [0, 0],
                tileSize: tileSize,
                minZoom: minZoom
              })
              const view = new View({
                resolutions: resolutions,
                extent: extent,
                projection: 'pixels',
                center: getCenter(extent),
                enableRotation: false,
                showFullExtent: true,
                constrainOnlyCenter: true
              })
              const tileLoadFunction = async (tile, src) => {
                const level = numLevels - tile.tileCoord[0] - 1
                const x = tile.tileCoord[1]
                const y = tile.tileCoord[2]
                const client = new XMLHttpRequest();
                const srcUrl = mds.getTileUrl(slide.id, level, x, y, 0)
                client.open('GET', srcUrl)
                client.responseType = 'blob'
                // fetching the user and token right before we set the Authorization header
                // this way we never use an expired token
                const user = await userManager.getUser()
                if (user && user.access_token) {
                  client.setRequestHeader('Authorization', `Bearer ${user.access_token}`)
                }
                client.addEventListener('loadend', function () {
                if (client.status === 200){
                  const data = this.response
                  if (data !== undefined) {
                    tile.getImage().src = URL.createObjectURL(data)
                  } else {
                    console.log("Error fetching tiles!")
                  }
                }
                })
                client.addEventListener('error', function () {
                  console.log("Connection error while fetching WSI tiles!")
                })
                client.send()
              }
              const source = new XYZ({
                url: 'DUMMY_URL', // URL is not used, but needs to be set
                tileLoadFunction: tileLoadFunction,
                tileGrid: tileGrid,
                projection: 'pixels',
                transition: 0,
              })
              const histoLayer = new Tile({
                source: source,
                preload: Infinity
              })
              const map = new Map({
                target: 'map',
                layers: [histoLayer],
                view: view,
                controls: [new ScaleLine({
                  minWidth: 100
                })]
              })
              map.getView().fit(extent, map.getSize())
              map.render()
            })
      }
  }
}
</script>

<style lang="css" scoped>
  @import 'https://cdn.jsdelivr.net/npm/ol@7.1.0/ol.css';
a {
  text-decoration: none
}
.html{
    box-sizing: border-box;
    -webkit-text-size-adjust: 100%;
    word-break: normal;
    -moz-tab-size: 4;
    tab-size:4
}
.body{
    -webkit-font-smoothing: antialiased;
    -moz-osx-font-smoothing: grayscale;
    font-family:  Opensans,sans-serif;
    color: #232323
}
.page-header{
  background-color: #fff;
  box-shadow: 0 3px 1px -2px #0003, 0 2px 2px #00000024, 0 1px 5px #0000001f;
  min-height: 56px
}
.header-logo{
  height: 56px;
  margin-left: 4px
}
.page-footer{
  background-color: #fff;
  border-top-color: #0000001f;
  border-top-width: 1px;
  border-top-style: solid;
  position: fixed
}
.text-empaia{
  color: #312783 !important
}
.bg-empaia{
  background: #312783 !important
}
.upload-item{
  border-top: 1px solid lightgray
}
.upload-item:hover{
  background-color: lightgray
}
.map{
  display: block;
  position: relative;
  height: 90%;
  width: 100%;
  top: 32px;
}
.ol-scale-line{
  background: rgba(255, 255, 255, 0.5);
  border-radius: 1px;
  bottom: 8px;
  left: 8px;
  padding: 2px;
  position: absolute
}
.ol-scale-line-inner{
  border-bottom: 1px solid black;
  border-left: 1px solid black;
  border-right: 1px solid black;
  color: black;
  font-family: Helvetica Neue, Helvetica, Arial, sans-serif;
  font-size: 15px;
  text-align: center
}
.ol-viewport{
  position: absolute
}
</style>
